## opencc 1.1.3%2Bds1

=== CMakeLists.txt ===
#
# Open Chinese Convert
#
# Copyright 2010-2020 Carbo Kuo <byvoid@byvoid.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

######## Project settings
cmake_minimum_required(VERSION 2.8)
set (PACKAGE_NAME opencc)
project (${PACKAGE_NAME} CXX)
include (CTest)

######## Options
option(BUILD_DOCUMENTATION "Use Doxygen to create the HTML based API documentation" OFF)
option(BUILD_SHARED_LIBS "Build opencc as shared library" ON)
option(ENABLE_GTEST "Build all tests." OFF)
option(ENABLE_BENCHMARK "Build benchmark tests." OFF)
option(ENABLE_DARTS "Build DartsDict (ocd format)." ON)
option(BUILD_PYTHON "Build python library" OFF)
option(USE_SYSTEM_DARTS "Use system version of Darts" OFF)
option(USE_SYSTEM_GOOGLE_BENCHMARK "Use system version of Google Benchmark" OFF)
option(USE_SYSTEM_GTEST "Use system version of GoogleTest" OFF)
option(USE_SYSTEM_MARISA "Use system version of Marisa" OFF)
option(USE_SYSTEM_PYBIND11 "Use system version of pybind11" OFF)
option(USE_SYSTEM_RAPIDJSON "Use system version of RapidJSON" OFF)
option(USE_SYSTEM_TCLAP "Use system version of TCLAP" OFF)

######## Package information
set (PACKAGE_URL https://github.com/BYVoid/Opencc)
set (PACKAGE_BUGREPORT https://github.com/BYVoid/Opencc/issues)
set (OPENCC_VERSION_MAJOR 1)
set (OPENCC_VERSION_MINOR 1)
set (OPENCC_VERSION_REVISION 3)

if (CMAKE_BUILD_TYPE MATCHES Debug)
  set (version_suffix .Debug)
endif (CMAKE_BUILD_TYPE MATCHES Debug)

set (
  OPENCC_VERSION
  ${OPENCC_VERSION_MAJOR}.${OPENCC_VERSION_MINOR}.${OPENCC_VERSION_REVISION}${version_suffix}
)

set(CPACK_SOURCE_PACKAGE_FILE_NAME
  "${PACKAGE_NAME}-${OPENCC_VERSION_MAJOR}.${OPENCC_VERSION_MINOR}.${OPENCC_VERSION_REVISION}"
)
set(CPACK_SOURCE_IGNORE_FILES
  "/build/;/test/dict.ocd;/test/dict.txt;/test/dict.bin;/other/;/opencc.xcodeproj/;/.git/;.gitignore;~$;.pyc;${CPACK_SOURCE_IGNORE_FILES}"
)
include(CPack)

######## Windows

#if (WIN32)
#  set(CMAKE_SHARED_LIBRARY_PREFIX ${CMAKE_INSTALL_PREFIX})
#  set(CMAKE_STATIC_LIBRARY_PREFIX ${CMAKE_INSTALL_PREFIX})
#endif (WIN32)

######## Mac OS X

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(CMAKE_MACOSX_RPATH 1)
endif()

######## Directory

set (DIR_PREFIX ${CMAKE_INSTALL_PREFIX})
set (DIR_INCLUDE ${DIR_PREFIX}/include/)
set (DIR_SHARE ${DIR_PREFIX}/share/)
set (DIR_ETC ${DIR_PREFIX}/etc/)
set (DIR_LIBRARY ${DIR_PREFIX}/lib${LIB_SUFFIX}/)

if (DEFINED SHARE_INSTALL_PREFIX)
  set (DIR_SHARE ${SHARE_INSTALL_PREFIX})
endif (DEFINED SHARE_INSTALL_PREFIX)

if (DEFINED INCLUDE_INSTALL_DIR)
  set (DIR_INCLUDE ${INCLUDE_INSTALL_DIR})
endif (DEFINED INCLUDE_INSTALL_DIR)

if (DEFINED SYSCONF_INSTALL_DIR)
  set (DIR_ETC ${SYSCONF_INSTALL_DIR})
endif (DEFINED SYSCONF_INSTALL_DIR)

if (DEFINED LIB_INSTALL_DIR)
  set (DIR_LIBRARY ${LIB_INSTALL_DIR})
endif (DEFINED LIB_INSTALL_DIR)

set (DIR_SHARE_OPENCC ${DIR_SHARE}/opencc/)
set (DIR_SHARE_LOCALE ${DIR_SHARE}/locale/)

######## Configuration

configure_file(
  opencc.pc.in
  opencc.pc
  @ONLY
)

install(
  FILES
    ${CMAKE_BINARY_DIR}/opencc.pc
  DESTINATION
    ${DIR_LIBRARY}/pkgconfig
)

######## Compiler flags

add_definitions(
  -DPKGDATADIR="${DIR_SHARE_OPENCC}"
  -DLOCALEDIR="${DIR_SHARE_LOCALE}"
  -DVERSION="${OPENCC_VERSION}"
  -DPACKAGE_NAME="${PACKAGE_NAME}"
)

if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
  add_definitions(
    -std=c++14
    -Wall
  )
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pthread")
  if (CMAKE_BUILD_TYPE MATCHES Debug)
    add_definitions(-O0 -g3)
  endif ()
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  add_definitions(
    -std=c++14
    -Wall
  )
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pthread")
  if (CMAKE_BUILD_TYPE MATCHES Debug)
    add_definitions(-O0 -g3)
  endif ()
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
  add_definitions(
    /W4
    /D "_CRT_SECURE_NO_WARNINGS"
  )
endif()

if (NOT BUILD_SHARED_LIBS)
  add_definitions(
    -DOpencc_BUILT_AS_STATIC
  )
endif (NOT BUILD_SHARED_LIBS)

if (ENABLE_GTEST)
  add_definitions(
    -DPROJECT_BINARY_DIR="${PROJECT_BINARY_DIR}"
    -DCMAKE_SOURCE_DIR="${CMAKE_SOURCE_DIR}"
  )
endif()

if (ENABLE_BENCHMARK)
  add_definitions(
    -DPROJECT_BINARY_DIR="${PROJECT_BINARY_DIR}"
    -DCMAKE_SOURCE_DIR="${CMAKE_SOURCE_DIR}"
  )
endif()

if (ENABLE_DARTS)
  add_definitions(
    -DENABLE_DARTS
  )
endif()


######## Dependencies

if(NOT USE_SYSTEM_MARISA)
  message(STATUS "Use bundled marisa library.")
  add_subdirectory(deps/marisa-0.2.6)
else()
  find_library(LIBMARISA NAMES marisa)
  if (LIBMARISA)
    message(STATUS "libmarisa found: ${LIBMARISA}")
  else()
    message(FATAL_ERROR "libmarisa not found.")
  endif()
endif()

######## Subdirectories

add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(data)
add_subdirectory(test)

######## Testing

if (ENABLE_GTEST)
  if(NOT USE_SYSTEM_GTEST)
    add_subdirectory(deps/gtest-1.11.0)
  endif()
  enable_testing()
endif()

if (ENABLE_BENCHMARK)
  set(BENCHMARK_ENABLE_TESTING OFF)
  if(NOT USE_SYSTEM_GOOGLE_BENCHMARK)
    add_subdirectory(deps/google-benchmark)
  endif()
  enable_testing()
endif()

######## Python

if (BUILD_PYTHON)
  if(USE_SYSTEM_PYBIND11)
    find_package(pybind11 CONFIG)
  else()
    add_subdirectory(deps/pybind11-2.5.0)
  endif()
  pybind11_add_module(opencc_clib src/py_opencc.cpp)
  target_link_libraries(opencc_clib PRIVATE libopencc)
endif()

## opencc 1.1.3+ds1

=== Makefile ===
#
# Open Chinese Convert
#
# Copyright 2010-2020 Carbo Kuo <byvoid@byvoid.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

PREFIX = /usr

.PHONY: build clean node test xcode-build

build:
	mkdir -p build/rel
	(cd build/rel; cmake \
	-DBUILD_DOCUMENTATION:BOOL=ON \
	-DENABLE_GTEST:BOOL=OFF \
	-DENABLE_BENCHMARK:BOOL=OFF \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_INSTALL_PREFIX=${PREFIX} \
	../..)
	make -C build/rel VERBOSE=${VERBOSE} PREFIX=${PREFIX}

package: build
	make -C build/rel package_source VERBOSE=${VERBOSE}
	make -C build/rel package_source VERBOSE=${VERBOSE} PREFIX=${PREFIX}

test:
	mkdir -p build/dbg/root
	(cd build/dbg; cmake \
	-DBUILD_DOCUMENTATION:BOOL=OFF \
	-DENABLE_GTEST:BOOL=ON \
	-DENABLE_BENCHMARK:BOOL=OFF \
	-DCMAKE_BUILD_TYPE=Debug \
	-DCMAKE_INSTALL_PREFIX=`pwd`/root \
	../..)
	make -C build/dbg VERBOSE=${VERBOSE}
	(cd build/dbg; ctest --verbose)
	make -C build/dbg install VERBOSE=${VERBOSE}

benchmark:
	mkdir -p build/perf
	(cd build/perf; cmake \
	-DBUILD_DOCUMENTATION:BOOL=OFF \
	-DENABLE_GTEST:BOOL=OFF \
	-DENABLE_BENCHMARK:BOOL=ON \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DCMAKE_INSTALL_PREFIX=`pwd`/root \
	../..)
	make -C build/perf VERBOSE=${VERBOSE} PREFIX=${PREFIX}
	(cd build/perf; ctest --verbose)

node:
	node-gyp configure
	node-gyp build

node-test: node
	npm test

xcode-build:
	mkdir -p xcode
	(cd xcode; cmake \
	-G "Xcode" \
	-DBUILD_DOCUMENTATION:BOOL=OFF \
	-DENABLE_GTEST:BOOL=ON \
	-DENABLE_BENCHMARK:BOOL=ON \
	..; \
	xcodebuild build)

python-build:
	python setup.py build_ext

python-install: python-build
	python setup.py install

python-dist: python-build
	python setup.py bdist_wheel

python-test: python-build
	cd python; pytest .

test-all: test node-test python-test

format:
	find "src" "node" "test" -iname "*.hpp" -o -iname "*.cpp" -o -iname "*.cc" \
	-o -iname "*.c" -o -iname "*.h" \
	| xargs clang-format -i

clean:
	rm -rf build xcode python/opencc/clib *.egg-info

install: build
	make -C build/rel install VERBOSE=${VERBOSE} PREFIX=${PREFIX}

=== src/CMakeLists.txt ===
include (GenerateExportHeader)

include_directories("${PROJECT_BINARY_DIR}/src")
include_directories("${PROJECT_SOURCE_DIR}/src")

if(NOT USE_SYSTEM_MARISA)
  include_directories(../deps/marisa-0.2.6/include)
endif()
if(NOT USE_SYSTEM_RAPIDJSON)
  include_directories(../deps/rapidjson-1.1.0)
endif()
if(NOT USE_SYSTEM_TCLAP)
  include_directories(../deps/tclap-1.2.2)
endif()

# Library

set(
  LIBOPENCC_HEADERS
  Common.hpp
  Config.hpp
  Conversion.hpp
  ConversionChain.hpp
  Converter.hpp
  Dict.hpp
  DictConverter.hpp
  DictEntry.hpp
  DictGroup.hpp
  Exception.hpp
  Export.hpp
  Lexicon.hpp
  MarisaDict.hpp
  MaxMatchSegmentation.hpp
  Optional.hpp
  PhraseExtract.hpp
  Segmentation.hpp
  Segments.hpp
  SerializableDict.hpp
  SerializedValues.hpp
  SimpleConverter.hpp
  TextDict.hpp
  UTF8StringSlice.hpp
  UTF8Util.hpp
  opencc.h
  "${PROJECT_BINARY_DIR}/src/opencc_config.h"
)

set(
  LIBOPENCC_SOURCES
  Config.cpp
  Conversion.cpp
  ConversionChain.cpp
  Converter.cpp
  Dict.cpp
  DictConverter.cpp
  DictEntry.cpp
  DictGroup.cpp
  Lexicon.cpp
  MarisaDict.cpp
  MaxMatchSegmentation.cpp
  PhraseExtract.cpp
  SerializedValues.cpp
  SimpleConverter.cpp
  Segmentation.cpp
  TextDict.cpp
  UTF8StringSlice.cpp
  UTF8Util.cpp
)

set(UNITTESTS
  ConfigTest
  ConversionChainTest
  ConversionTest
  DictGroupTest
  MarisaDictTest
  MaxMatchSegmentationTest
  PhraseExtractTest
  SerializedValuesTest
  SimpleConverterTest
  TextDictTest
  UTF8StringSliceTest
  UTF8UtilTest
)

if (ENABLE_DARTS)
  set(OPENCC_ENABLE_DARTS 1)
  if(NOT USE_SYSTEM_DARTS)
    include_directories(../deps/darts-clone)
  endif()
  set(
    LIBOPENCC_HEADERS
    ${LIBOPENCC_HEADERS}
    BinaryDict.hpp
    DartsDict.hpp
  )
  set(
    LIBOPENCC_SOURCES
    ${LIBOPENCC_SOURCES}
    BinaryDict.cpp
    DartsDict.cpp
  )
  set(
    UNITTESTS
    ${UNITTESTS}
    BinaryDictTest
    DartsDictTest
  )
endif()

configure_file(
  "${PROJECT_SOURCE_DIR}/src/opencc_config.h.in"
  "${PROJECT_BINARY_DIR}/src/opencc_config.h")

add_library(libopencc ${LIBOPENCC_SOURCES} ${LIBOPENCC_HEADERS})
set_target_properties(libopencc PROPERTIES POSITION_INDEPENDENT_CODE ON)
source_group(libopencc FILES ${LIBOPENCC_SOURCES} ${LIBOPENCC_HEADERS})
target_link_libraries(libopencc marisa)

GENERATE_EXPORT_HEADER(
  libopencc
  BASE_NAME OPENCC
  EXPORT_MACRO_NAME OPENCC_EXPORT
  EXPORT_FILE_NAME Opencc_Export.h
  STATIC_DEFINE Opencc_BUILT_AS_STATIC
)

set_target_properties(
  libopencc
  PROPERTIES
    LINKER_LANGUAGE
      CXX
    OUTPUT_NAME
      opencc
    VERSION
      1.1.3
    SOVERSION
      1.1
)

# Installation

install(
  TARGETS libopencc
  LIBRARY DESTINATION ${DIR_LIBRARY}
  ARCHIVE DESTINATION ${DIR_LIBRARY}
  RUNTIME DESTINATION bin
)

install(
  FILES ${LIBOPENCC_HEADERS}
  DESTINATION ${DIR_INCLUDE}/opencc
)

# Gtest

if (ENABLE_GTEST)
  if (WIN32)
    add_custom_target(
        copy_gtest_to_src
        ${CMAKE_COMMAND} -E copy $<TARGET_FILE:gtest> ${CMAKE_CURRENT_BINARY_DIR}
      COMMENT "Copying gtest to src"
    )
    add_custom_target(
        copy_gtest_main_to_src
        ${CMAKE_COMMAND} -E copy $<TARGET_FILE:gtest_main> ${CMAKE_CURRENT_BINARY_DIR}
      COMMENT "Copying gtest_main to src"
    )
  endif()

  foreach(TESTCASE ${UNITTESTS})
    add_executable(${TESTCASE} ${TESTCASE}.cpp)
    target_link_libraries(${TESTCASE} gtest gtest_main libopencc)
    add_test(${TESTCASE} ${TESTCASE})
    if (WIN32)
      add_dependencies(${TESTCASE} copy_gtest_to_src copy_gtest_main_to_src)
    endif()
  endforeach()
endif()

# Benchmark

if (ENABLE_BENCHMARK)
  add_subdirectory(benchmark)
endif()

# Subdir

add_subdirectory(tools)

=== src/benchmark/CMakeLists.txt ===
add_executable(performance Performance.cpp)
target_link_libraries(performance benchmark libopencc)
add_test(BenchmarkTest performance)

if (WIN32)
  add_custom_target(
    copy_benchmark
    ${CMAKE_COMMAND} -E copy $<TARGET_FILE:benchmark> ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Copying benchmark to src/benchmark"
  )
  add_custom_target(
    copy_libopencc
    ${CMAKE_COMMAND} -E copy $<TARGET_FILE:libopencc> ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Copying libopencc to src/benchmark"
  )
  add_dependencies(performance copy_benchmark copy_libopencc)
endif()

=== src/tools/CMakeLists.txt ===
# Executables

## opencc
add_executable(opencc CommandLine.cpp)
target_link_libraries(opencc libopencc)

## opencc_dict
add_executable(opencc_dict DictConverter.cpp)
target_link_libraries(opencc_dict libopencc)

## opencc_phrase_extract
add_executable(opencc_phrase_extract PhraseExtract.cpp)
target_link_libraries(opencc_phrase_extract libopencc)

# Installation

install(
  TARGETS opencc opencc_dict opencc_phrase_extract
  RUNTIME DESTINATION bin
)

=== debian/changelog ===
opencc (1.1.3+ds1-3ubuntu3) jammy; urgency=high

  * No change rebuild for ppc64el baseline bump.

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 24 Mar 2022 17:21:57 +0100

opencc (1.1.3+ds1-3ubuntu2) jammy; urgency=medium

  * Refresh symbols also for riscv64 on Ubuntu

 -- Gunnar Hjalmarsson <gunnarhj@ubuntu.com>  Tue, 19 Oct 2021 00:59:09 +0200

opencc (1.1.3+ds1-3ubuntu1) jammy; urgency=medium

  * Merge with Debian, remaining changes:
    - Symbols file modified for Ubuntu
  * Refresh symbols for Ubuntu

 -- Gunnar Hjalmarsson <gunnarhj@ubuntu.com>  Tue, 19 Oct 2021 00:00:44 +0200

opencc (1.1.3+ds1-3) unstable; urgency=medium

  * Refresh symbols again for all archs using buildd logs.

 -- Boyuan Yang <byang@debian.org>  Mon, 20 Sep 2021 15:44:37 -0400

opencc (1.1.3+ds1-2) unstable; urgency=medium

  * Refresh symbols for all archs using buildd logs.

 -- Boyuan Yang <byang@debian.org>  Sun, 19 Sep 2021 16:32:52 -0400

opencc (1.1.3+ds1-1) unstable; urgency=medium

  * New upstream release 1.1.3.
  * Add myself into uploaders list.
  * debian/patches: Refresh patches.
    + 0002-use-system-libraries.patch: Dropped, upstream now provides
      CMake options to use system libraries.
    + Drop backported patches (0006, 0007), merged upstream.
  * debian/control:
    + Bump Standards-Version to 4.6.0.
    + Add new build-dependency pybind11-dev.
  * debian/rules: Refresh cmake build options.
  * debian/libopencc1.1.symbols: Refresh symbols.

 -- Boyuan Yang <byang@debian.org>  Sat, 18 Sep 2021 21:13:03 -0400

opencc (1.1.1+git20200624+ds2-10ubuntu3) impish; urgency=medium

  * Further symbols file modification to prevent FTBFS

 -- Gunnar Hjalmarsson <gunnarhj@ubuntu.com>  Wed, 11 Aug 2021 14:19:15 +0200

opencc (1.1.1+git20200624+ds2-10ubuntu2) hirsute; urgency=medium

  * Further symbols file modification to prevent FTBFS
    - Most archs tweaked compared to Debian

 -- Gunnar Hjalmarsson <gunnarhj@ubuntu.com>  Mon, 29 Mar 2021 14:12:10 +0200

opencc (1.1.1+git20200624+ds2-10ubuntu1) hirsute; urgency=medium

  * Merge with Debian (LP: #1917909), remaining changes:
    - Symbols file modified for armhf, i386 and s390x

 -- Gunnar Hjalmarsson <gunnarhj@ubuntu.com>  Sun, 07 Mar 2021 16:19:22 +0100

opencc (1.1.1+git20200624+ds2-6ubuntu1) hirsute; urgency=medium

  * Merge with Debian (LP: #1917310), remaining changes:
    - Symbols file modified for armhf, i386 and s390x

 -- Gunnar Hjalmarsson <gunnarhj@ubuntu.com>  Mon, 01 Mar 2021 13:28:03 +0100

opencc (1.1.1+git20200624+ds2-5ubuntu1) hirsute; urgency=medium

  * Merge with Debian, remaining changes:
    - Symbols file modified for armhf, i386 and s390x

 -- Gunnar Hjalmarsson <gunnarhj@ubuntu.com>  Thu, 18 Feb 2021 23:03:00 +0100

opencc (1.1.1+git20200624+ds2-4ubuntu1) hirsute; urgency=medium

  * debian/libopencc1.1.symbols:
    - Refreshed due to s390x on Ubuntu (LP: #1912882)

 -- Gunnar Hjalmarsson <gunnarhj@ubuntu.com>  Sat, 23 Jan 2021 11:12:00 +0100

=== debian/control ===
Source: opencc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Debian Chinese Team <chinese-developers@lists.alioth.debian.org>,
 Asias He <asias@debian.org>,
 YunQiang Su <syq@debian.org>,
 Osamu Aoki <osamu@debian.org>,
 Aron Xu <aron@debian.org>,
 xiao sheng wen <atzlinux@sina.com>,
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake,
 darts,
 debhelper-compat (= 13),
 doxygen <!nodoc>,
 googletest <!nocheck>,
 libmarisa-dev,
 libtclap-dev,
 pkg-kde-tools,
 pybind11-dev,
 python3:any,
 rapidjson-dev,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Section: libs
Homepage: https://github.com/BYVoid/OpenCC
Vcs-Git: https://salsa.debian.org/debian/opencc.git
Vcs-Browser: https://salsa.debian.org/debian/opencc

Package: libopencc-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Breaks:
 libopencc2-data (<< 1.1.1~),
Replaces:
 libopencc2-data (<< 1.1.1~),
Description: simplified-traditional Chinese conversion library - data files
 opencc is a library for converting character between traditional Chinese and
 simplified Chinese.
 .
 This package includes the data files.

Package: libopencc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libopencc1.1 (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 libopencc-doc,
Description: simplified-traditional Chinese conversion library - development
 opencc is a library for converting character between traditional Chinese and
 simplified Chinese.
 .
 This package includes the development support files.

Package: libopencc-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends},
Description: simplified-traditional Chinese conversion library - document
 opencc is a library for converting character between traditional Chinese and
 simplified Chinese.
 .
 This package includes the library document files.

Package: libopencc1.1
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libopencc-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: simplified-traditional Chinese conversion library - runtime
 opencc is a library for converting character between traditional Chinese and
 simplified Chinese.
 .
 This package includes the shared library.

Package: opencc
Section: utils
Architecture: any
Multi-Arch: foreign
Depends:
 libopencc1.1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 libopencc-doc,
Description: simplified-traditional Chinese conversion tool
 opencc is a library for converting character between traditional Chinese and
 simplified Chinese.
 .
 This package includes the conversion tool.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk

# Disable parallel build to circumvent some random build error
# (needs further investigation)
%:
	dh $@ --buildsystem=cmake --with pkgkde_symbolshelper --no-parallel

BUILD_OPTIONS = \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)/ \
    -DCMAKE_BUILD_TYPE=Release \
    -DUSE_SYSTEM_DARTS=ON \
    -DUSE_SYSTEM_GTEST=ON \
    -DUSE_SYSTEM_MARISA=ON \
    -DUSE_SYSTEM_PYBIND11=ON \
    -DUSE_SYSTEM_RAPIDJSON=ON \
    -DUSE_SYSTEM_TCLAP=ON

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
BUILD_OPTIONS += -DBUILD_DOCUMENTATION=ON
else
BUILD_OPTIONS += -DBUILD_DOCUMENTATION=OFF
endif

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
BUILD_OPTIONS += -DENABLE_GTEST=ON
else
BUILD_OPTIONS += -DENABLE_GTEST=OFF
endif

override_dh_auto_configure:
	dh_auto_configure -- $(BUILD_OPTIONS)

execute_after_dh_auto_clean:
	find . -name *.pyc -delete

execute_after_dh_installdocs-indep:
ifeq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
	dh_doxygen --indep
endif

override_dh_installdocs:
	dh_installdocs -plibopencc-doc --doc-main-package=opencc
	dh_installdocs --remaining-packages

override_dh_installchangelogs:
	dh_installchangelogs -k NEWS.md

## opencc 1.1.4%2Bds1

=== debian/changelog ===
opencc (1.1.4+ds1-4deepin) unstable; urgency=medium

  * Regulate version name

 -- Yutao Meng <mengyutao@uniontech.com>  Mon, 20 Mar 2023 11:40:57 +0800

opencc (1.1.4+ds1-4) unstable; urgency=medium

  * Team upload
  * Work around uscan issue with GitHub releases page

 -- Gunnar Hjalmarsson <gunnarhj@debian.org>  Tue, 08 Nov 2022 16:33:54 +0100

opencc (1.1.4+ds1-3) unstable; urgency=medium

  * Team upload
  * debian/libopencc1.1.symbols:
    - Update other archs for LTO using buildd logs (closes: #1015565)
  * Build with GCC-12
    - It builds fine now with GCC-12, so the symbols fix for LTO also
      closes: #1013008.

 -- Gunnar Hjalmarsson <gunnarhj@debian.org>  Mon, 25 Jul 2022 02:26:42 +0200

opencc (1.1.4+ds1-2) unstable; urgency=medium

  * Team upload
  * Start fixing FTBFS with LTO enabled (see bug 1015565):
    - debian/rules: Enable LTO
    - Create symbols file for amd64 only
  * Bump Standards-Version to 4.6.1
  * debian/copyright: Bump copyright year to 2022

 -- Gunnar Hjalmarsson <gunnarhj@debian.org>  Sat, 23 Jul 2022 19:05:33 +0200

opencc (1.1.4+ds1-1) unstable; urgency=medium

  [ xiao sheng wen ]
  * update-debian-copyright to 2021 year.

  [ Boyuan Yang ]
  * New upstream version 1.1.4+ds1.
  * debian/patches: Refresh patches.
  * debian/libopencc1.1.symbols: Refresh symbols.

 -- Boyuan Yang <byang@debian.org>  Sat, 04 Jun 2022 11:52:24 -0400

opencc (1.1.3+ds1-5) unstable; urgency=medium

  * Team upload
  * debian/libopencc1.1.symbols:
    - Refresh using buildd logs for all archs and pkgkde-symbolshelper
      (Closes: #997412)

 -- Gunnar Hjalmarsson <gunnarhj@debian.org>  Wed, 27 Oct 2021 09:39:59 +0200

opencc (1.1.3+ds1-4) unstable; urgency=medium

  * Team upload
  * Re-build with GCC 11
  * debian/libopencc1.1.symbols:
    - amd64 tweak using buildd log from test rebuild

 -- Gunnar Hjalmarsson <gunnarhj@debian.org>  Tue, 26 Oct 2021 23:03:58 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: opencc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
+Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
 Uploaders:
  Debian Chinese Team <chinese-developers@lists.alioth.debian.org>,
  Asias He <asias@debian.org>,
@@ -22,7 +21,7 @@
  pybind11-dev,
  python3:any,
  rapidjson-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Section: libs
 Homepage: https://github.com/BYVoid/OpenCC

## opencc 1.1.4+ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -42,7 +42,7 @@
 set (PACKAGE_BUGREPORT https://github.com/BYVoid/Opencc/issues)
 set (OPENCC_VERSION_MAJOR 1)
 set (OPENCC_VERSION_MINOR 1)
-set (OPENCC_VERSION_REVISION 3)
+set (OPENCC_VERSION_REVISION 4)
 
 if (CMAKE_BUILD_TYPE MATCHES Debug)
   set (version_suffix .Debug)

## opencc 1.1.6+ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 #
 
 ######## Project settings
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 3.5)
 set (PACKAGE_NAME opencc)
 project (${PACKAGE_NAME} CXX)
 include (CTest)
@@ -42,7 +42,7 @@
 set (PACKAGE_BUGREPORT https://github.com/BYVoid/Opencc/issues)
 set (OPENCC_VERSION_MAJOR 1)
 set (OPENCC_VERSION_MINOR 1)
-set (OPENCC_VERSION_REVISION 4)
+set (OPENCC_VERSION_REVISION 5)
 
 if (CMAKE_BUILD_TYPE MATCHES Debug)
   set (version_suffix .Debug)
@@ -72,6 +72,8 @@
 
 if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
     set(CMAKE_MACOSX_RPATH 1)
+    set(CMAKE_CXX_STANDARD 14)
+    set(CMAKE_CXX_STANDARD_REQUIRED ON)
 endif()
 
 ######## Directory
@@ -111,7 +113,7 @@
 
 install(
   FILES
-    ${CMAKE_BINARY_DIR}/opencc.pc
+    ${CMAKE_CURRENT_BINARY_DIR}/opencc.pc
   DESTINATION
     ${DIR_LIBRARY}/pkgconfig
 )
@@ -202,7 +204,7 @@
 
 if (ENABLE_GTEST)
   if(NOT USE_SYSTEM_GTEST)
-    add_subdirectory(deps/gtest-1.11.0)
+    add_subdirectory(deps/gtest-1.12.1)
   endif()
   enable_testing()
 endif()
@@ -221,7 +223,7 @@
   if(USE_SYSTEM_PYBIND11)
     find_package(pybind11 CONFIG)
   else()
-    add_subdirectory(deps/pybind11-2.5.0)
+    add_subdirectory(deps/pybind11-2.10.0)
   endif()
   pybind11_add_module(opencc_clib src/py_opencc.cpp)
   target_link_libraries(opencc_clib PRIVATE libopencc)

=== data/CMakeLists.txt ===
find_package(PythonInterp REQUIRED)

set(OPENCC_DICT_BIN opencc_dict)
set(DICT_MERGE_BIN "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/scripts/merge.py")
set(DICT_REVERSE_BIN "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/scripts/reverse.py")
set(DICT_DIR ${CMAKE_CURRENT_SOURCE_DIR}/dictionary)
set(DICT_GENERATED_DIR ${CMAKE_CURRENT_BINARY_DIR})

set(
  DICTS_RAW
  STCharacters
  STPhrases
  TSCharacters
  TSPhrases
  TWVariants
  TWVariantsRevPhrases
  HKVariants
  HKVariantsRevPhrases
  JPVariants
  JPShinjitaiCharacters
  JPShinjitaiPhrases
)

set(
  DICTS_GENERATED
  TWPhrases
  TWPhrasesRev
  TWVariantsRev
  HKVariantsRev
  JPVariantsRev
)

set(DICTS ${DICTS_RAW} ${DICTS_GENERATED})

foreach(DICT ${DICTS})
  set(DICT_TARGETS ${DICT_TARGETS} ${DICT}.ocd2)
endforeach(DICT)

add_custom_target(
  Dictionaries
  ALL
  DEPENDS
    ${DICT_TARGETS}
)

foreach(DICT ${DICTS_RAW})
  set(DICT_${DICT}_INPUT ${DICT_DIR}/${DICT}.txt)
endforeach(DICT)

foreach(DICT ${DICTS_GENERATED})
  set(DICT_${DICT}_INPUT ${DICT_GENERATED_DIR}/${DICT}.txt)
endforeach(DICT)

set(
  DICT_TWPhrases_GENERATING_INPUT
  ${DICT_DIR}/TWPhrasesIT.txt
  ${DICT_DIR}/TWPhrasesName.txt
  ${DICT_DIR}/TWPhrasesOther.txt
)
set(
  DICT_TWPhrases_GENERATING_COMMAND
  ${DICT_MERGE_BIN} ${DICT_TWPhrases_GENERATING_INPUT} TWPhrases.txt
)

set(
  DICT_TWVariantsRev_GENERATING_INPUT
  ${DICT_DIR}/TWVariants.txt
)
set(
  DICT_TWVariantsRev_GENERATING_COMMAND
  ${DICT_REVERSE_BIN} ${DICT_TWVariantsRev_GENERATING_INPUT} TWVariantsRev.txt
)

set(
  DICT_TWPhrasesRev_GENERATING_INPUT
  ${DICT_GENERATED_DIR}/TWPhrases.txt
)
set(
  DICT_TWPhrasesRev_GENERATING_COMMAND
  ${DICT_REVERSE_BIN} ${DICT_TWPhrasesRev_GENERATING_INPUT} TWPhrasesRev.txt
)

set(
  DICT_HKVariantsRev_GENERATING_INPUT
  ${DICT_DIR}/HKVariants.txt
)
set(
  DICT_HKVariantsRev_GENERATING_COMMAND
  ${DICT_REVERSE_BIN} ${DICT_HKVariantsRev_GENERATING_INPUT} HKVariantsRev.txt
)

set(
  DICT_JPVariantsRev_GENERATING_INPUT
  ${DICT_DIR}/JPVariants.txt
)
set(
  DICT_JPVariantsRev_GENERATING_COMMAND
  ${DICT_REVERSE_BIN} ${DICT_JPVariantsRev_GENERATING_INPUT} JPVariantsRev.txt
)

foreach(DICT ${DICTS_GENERATED})
  add_custom_command(
    OUTPUT
      ${DICT}.txt
    COMMENT
      "Generating ${DICT}.txt"
    COMMAND
      ${DICT_${DICT}_GENERATING_COMMAND}
    DEPENDS
      ${DICT_${DICT}_GENERATING_INPUT}
  )
  set_directory_properties(
    PROPERTIES
      ADDITIONAL_MAKE_CLEAN_FILES
        "${DICT_GENERATED_DIR}/${DICT}.txt"
  )
endforeach(DICT)

add_custom_target(
  copy_libopencc_to_dir_of_opencc_dict
  COMMENT
    "Copying libopencc to directory of opencc_dict"
  COMMAND
    ${CMAKE_COMMAND} -E copy "$<TARGET_FILE:libopencc>" "$<TARGET_FILE_DIR:${OPENCC_DICT_BIN}>"
)
if (WIN32)
  set(DICT_WIN32_DEPENDS copy_libopencc_to_dir_of_opencc_dict)
else()
  set(DICT_WIN32_DEPENDS)
endif()

foreach(DICT ${DICTS})
  add_custom_command(
    OUTPUT
      ${DICT}.ocd2
    COMMENT
      "Building ${DICT}.ocd2"
    COMMAND
      ${OPENCC_DICT_BIN}
        --input ${DICT_${DICT}_INPUT}
        --output ${DICT}.ocd2
        --from text
        --to ocd2
    DEPENDS
      ${DICT_WIN32_DEPENDS}
      ${OPENCC_DICT_BIN}
      ${DICT_${DICT}_INPUT}
  )

  install(
    FILES
      ${DICT_GENERATED_DIR}/${DICT}.ocd2
    DESTINATION
      ${DIR_SHARE_OPENCC}
  )

  set_directory_properties(
    PROPERTIES
      ADDITIONAL_MAKE_CLEAN_FILES
        "${DICT_GENERATED_DIR}/${DICT}.ocd2"
  )
endforeach(DICT)

set(CONFIG_FILES
  config/hk2s.json
  config/hk2t.json
  config/jp2t.json
  config/s2hk.json
  config/s2t.json
  config/s2tw.json
  config/s2twp.json
  config/t2hk.json
  config/t2jp.json
  config/t2s.json
  config/t2tw.json
  config/tw2s.json
  config/tw2sp.json
  config/tw2t.json
)

install(
  FILES
    ${CONFIG_FILES}
  DESTINATION
    ${DIR_SHARE_OPENCC}
)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -132,9 +132,9 @@
     OUTPUT_NAME
       opencc
     VERSION
-      1.1.3
+      ${OPENCC_VERSION_MAJOR}.${OPENCC_VERSION_MINOR}.${OPENCC_VERSION_REVISION}
     SOVERSION
-      1.1
+      ${OPENCC_VERSION_MAJOR}.${OPENCC_VERSION_MINOR}
 )
 
 # Installation

=== debian/changelog ===
opencc (1.1.6+ds1-1) unstable; urgency=medium

  * Team upload
  * New upstream version 1.1.6+ds1
  * Refresh patches:
    - d/p/0001-use-cmake-install-libdir.patch
    - d/p/0005-Use-system-googletest.patch

 -- Gunnar Hjalmarsson <gunnarhj@debian.org>  Sat, 10 Dec 2022 13:10:03 +0100

opencc (1.1.5+ds1-1) unstable; urgency=medium

  * Team upload
  * New upstream version 1.1.5+ds1

 -- Gunnar Hjalmarsson <gunnarhj@debian.org>  Tue, 06 Dec 2022 13:40:36 +0100

## opencc 1.1.7%2Bds1

=== debian/changelog ===
opencc (1.1.7+ds1-1build1) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:14:49 +0200

opencc (1.1.7+ds1-1) unstable; urgency=medium

  * Team upload
  * New upstream version 1.1.7+ds1
  * debian/libopencc-dev.install:
    - Install CMake config modules

 -- Gunnar Hjalmarsson <gunnarhj@debian.org>  Sat, 21 Oct 2023 21:22:49 +0200

opencc (1.1.6+ds1-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Add B-D: opencc <cross> for opencc_dict. (Closes: #1051036)

 -- Boyuan Yang <byang@debian.org>  Fri, 01 Sep 2023 12:00:26 -0400

## opencc 1.1.7+ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -42,7 +42,7 @@
 set (PACKAGE_BUGREPORT https://github.com/BYVoid/Opencc/issues)
 set (OPENCC_VERSION_MAJOR 1)
 set (OPENCC_VERSION_MINOR 1)
-set (OPENCC_VERSION_REVISION 5)
+set (OPENCC_VERSION_REVISION 7)
 
 if (CMAKE_BUILD_TYPE MATCHES Debug)
   set (version_suffix .Debug)
@@ -105,6 +105,10 @@
 
 ######## Configuration
 
+include(CMakePackageConfigHelpers)
+
+set(targets_export_name OpenCCTargets)
+
 configure_file(
   opencc.pc.in
   opencc.pc
@@ -116,6 +120,27 @@
     ${CMAKE_CURRENT_BINARY_DIR}/opencc.pc
   DESTINATION
     ${DIR_LIBRARY}/pkgconfig
+)
+
+write_basic_package_version_file(
+  OpenCCConfigVersion.cmake
+  VERSION ${OPENCC_VERSION}
+  COMPATIBILITY SameMajorVersion
+)
+
+configure_package_config_file(
+  OpenCCConfig.cmake.in
+  ${CMAKE_CURRENT_BINARY_DIR}/OpenCCConfig.cmake
+  INSTALL_DESTINATION ${DIR_LIBRARY}/cmake/opencc
+  PATH_VARS DIR_INCLUDE
+)
+
+install(
+  FILES
+    ${CMAKE_CURRENT_BINARY_DIR}/OpenCCConfig.cmake
+    ${CMAKE_CURRENT_BINARY_DIR}/OpenCCConfigVersion.cmake
+  DESTINATION
+    ${DIR_LIBRARY}/cmake/opencc
 )
 
 ######## Compiler flags

=== doc/CMakeLists.txt ===
if(BUILD_DOCUMENTATION)
    find_package(Doxygen)
    if (NOT DOXYGEN_FOUND)
        message(
            FATAL_ERROR 
            "Doxygen is needed to build the documentation. Please install it correctly"
        )
    endif()

    configure_file(
    	opencc.doxy.in
    	opencc.doxy
    	@ONLY
        IMMEDIATE
    )

    add_custom_target(
    	apidoc
    	ALL
    	COMMENT
    		"Building API Documentation"
    	COMMAND
    		doxygen ${PROJECT_BINARY_DIR}/doc/opencc.doxy
        SOURCES
            ${PROJECT_BINARY_DIR}/doc/opencc.doxy
    )

    install(
    	DIRECTORY
    		${CMAKE_BINARY_DIR}/doc/html
    	DESTINATION
    		${DIR_SHARE_OPENCC}/doc
    )

    set_directory_properties(
    	PROPERTIES
    		ADDITIONAL_MAKE_CLEAN_FILES
    			"${CMAKE_BINARY_DIR}/doc/html"
    )
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -112,9 +112,14 @@
   "${PROJECT_BINARY_DIR}/src/opencc_config.h")
 
 add_library(libopencc ${LIBOPENCC_SOURCES} ${LIBOPENCC_HEADERS})
+add_library(OpenCC::OpenCC ALIAS libopencc)
 set_target_properties(libopencc PROPERTIES POSITION_INDEPENDENT_CODE ON)
 source_group(libopencc FILES ${LIBOPENCC_SOURCES} ${LIBOPENCC_HEADERS})
 target_link_libraries(libopencc marisa)
+target_include_directories(libopencc PUBLIC
+    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
+    $<INSTALL_INTERFACE:${DIR_INCLUDE}/opencc>
+)
 
 GENERATE_EXPORT_HEADER(
   libopencc
@@ -131,6 +136,8 @@
       CXX
     OUTPUT_NAME
       opencc
+    EXPORT_NAME
+      OpenCC
     VERSION
       ${OPENCC_VERSION_MAJOR}.${OPENCC_VERSION_MINOR}.${OPENCC_VERSION_REVISION}
     SOVERSION
@@ -139,11 +146,24 @@
 
 # Installation
 
+if (USE_SYSTEM_MARISA)
+  set(INSTALL_TARGETS libopencc)
+else()
+  set(INSTALL_TARGETS libopencc marisa)
+endif()
+
 install(
-  TARGETS libopencc
+  TARGETS ${INSTALL_TARGETS} EXPORT ${targets_export_name}
   LIBRARY DESTINATION ${DIR_LIBRARY}
   ARCHIVE DESTINATION ${DIR_LIBRARY}
   RUNTIME DESTINATION bin
+)
+
+install(
+  EXPORT ${targets_export_name}
+  FILE ${targets_export_name}.cmake
+  DESTINATION ${DIR_LIBRARY}/cmake/opencc
+  NAMESPACE OpenCC::
 )
 
 install(

=== test/CMakeLists.txt ===
include_directories("${PROJECT_BINARY_DIR}/src")
include_directories("${PROJECT_SOURCE_DIR}/src")

set(CONFIG_TEST
  config_test/config_test.json
  config_test/config_test_characters.txt
  config_test/config_test_phrases.txt
)

set(CONFIG_TEST_TARGET_DIR ${PROJECT_BINARY_DIR}/test/config_test)
make_directory(${CONFIG_TEST_TARGET_DIR})
foreach (CONFIG_TEST_FILE ${CONFIG_TEST})
  configure_file(${CONFIG_TEST_FILE} ${CONFIG_TEST_TARGET_DIR} COPYONLY)
endforeach (CONFIG_TEST_FILE)

if (ENABLE_GTEST)
  if (WIN32)
    add_custom_target(
        copy_gtest_to_test
        ${CMAKE_COMMAND} -E copy $<TARGET_FILE:gtest> ${CMAKE_CURRENT_BINARY_DIR}
      COMMENT "Copying gtest to test"
    )
    add_custom_target(
        copy_gtest_main_to_test
        ${CMAKE_COMMAND} -E copy $<TARGET_FILE:gtest_main> ${CMAKE_CURRENT_BINARY_DIR}
      COMMENT "Copying gtest_main to test"
    )
  endif()

  if(NOT USE_SYSTEM_GTEST)
    include_directories(../deps/gtest-1.7.0/include)
  endif()
  set(UNITTESTS
    CommandLineConvertTest
  )
  foreach(UNITTEST ${UNITTESTS})
    add_executable(${UNITTEST} ${UNITTEST}.cpp)
    target_link_libraries(${UNITTEST} gtest gtest_main libopencc)
    add_test(${UNITTEST} ${UNITTEST})
    if (WIN32)
      add_dependencies(${UNITTEST} copy_gtest_to_test copy_gtest_main_to_test)
    endif()
  endforeach(UNITTEST)
endif()

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: opencc
 Priority: optional
-Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
 Uploaders:
  Debian Chinese Team <chinese-developers@lists.alioth.debian.org>,
  Asias He <asias@debian.org>,
@@ -17,11 +18,12 @@
  googletest <!nocheck>,
  libmarisa-dev,
  libtclap-dev,
+ opencc <cross>,
  pkg-kde-tools,
  pybind11-dev,
  python3:any,
  rapidjson-dev,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Section: libs
 Homepage: https://github.com/BYVoid/OpenCC

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # export DH_VERBOSE=1
 
 # see FEATURE AREAS in dpkg-buildflags(1)
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto
 
 include /usr/share/dpkg/architecture.mk

=== debian/tests/control ===
Tests: integration
Depends:
 build-essential,
 cmake,
 googletest,
 pkg-config,
 @,
Restrictions: allow-stderr,

## opencc 1.1.9%2Bds1

=== debian/changelog ===
opencc (1.1.9+ds1-3) unstable; urgency=medium

  * debian/control: Bump Standards-Version to 4.7.2.
  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Sun, 28 Sep 2025 19:36:20 -0400

opencc (1.1.9+ds1-3~exp1) experimental; urgency=medium

  * Test rebuild against libmarisa 0.3.1.

 -- Boyuan Yang <byang@debian.org>  Tue, 23 Sep 2025 20:07:44 -0400

opencc (1.1.9+ds1-2) unstable; urgency=medium

  * debian/patches/backport/0006-Fix-build-for-gcc-15-934.patch,
    debian/patches/backport/0007-Fix-deprecated-declarations-in-C-17.patch:
    Backport upstream patches to fix FTBFS with GCC 15. (Closes: #1097512)
  * debian/patches/0002-Force-build-with-c-17.patch: Force building with
    c++17 standard to fix FTBFS with the new googletest.

 -- Boyuan Yang <byang@debian.org>  Tue, 09 Sep 2025 08:26:01 -0400

opencc (1.1.9+ds1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Wed, 14 Aug 2024 14:05:52 -0400

opencc (1.1.9+ds1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * debian/control: Add new build-test-dependency python3-pytest.
  * debian/patches/0002: Dropped, merged upstream.
  * debian/libopencc1.1.symbols: Update symbols.
  * debian/rules: Allow python binding post-build test failure for now
    before we find out the correct way to test the python package with
    pytest.

 -- Boyuan Yang <byang@debian.org>  Wed, 14 Aug 2024 12:32:59 -0400

opencc (1.1.8+ds1-3) unstable; urgency=medium

  * Upload to unstable. Closes: #1077816
  * debian/control: Move main description to source package section.
  * debian/control: Add new build-dependency pybuild-plugin-pyproject.
  * debian/control: Use dh-sequence-python3.
  * debian/rules: Use pyproject instead of distutils for pybuild.

 -- Boyuan Yang <byang@debian.org>  Sat, 03 Aug 2024 19:07:26 -0400

opencc (1.1.8+ds1-2) experimental; urgency=medium

  * Team upload

  [ Shengjing Zhu ]
  * Disable build in setup.py

  [ Felix Yan ]
  * Enable python binding (Closes: #1077816)

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 03 Aug 2024 13:38:47 +0800

opencc (1.1.8+ds1-1) unstable; urgency=medium

  * Upload to unstable.
  * debian/libopencc1.1.symbols: Reconfirm symbols.

 -- Boyuan Yang <byang@debian.org>  Mon, 29 Jul 2024 12:07:48 -0400

opencc (1.1.8+ds1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * debian/copyright: Update information.
  * debian/patches: Refresh patches.
  * debian/control: Use dh-sequence-pkgkde-symbolshelper.

 -- Boyuan Yang <byang@debian.org>  Sun, 28 Jul 2024 20:00:37 -0400

## opencc 1.1.9+ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -38,11 +38,11 @@
 option(USE_SYSTEM_TCLAP "Use system version of TCLAP" OFF)
 
 ######## Package information
-set (PACKAGE_URL https://github.com/BYVoid/Opencc)
-set (PACKAGE_BUGREPORT https://github.com/BYVoid/Opencc/issues)
+set (PACKAGE_URL https://github.com/BYVoid/OpenCC)
+set (PACKAGE_BUGREPORT https://github.com/BYVoid/OpenCC/issues)
 set (OPENCC_VERSION_MAJOR 1)
 set (OPENCC_VERSION_MINOR 1)
-set (OPENCC_VERSION_REVISION 7)
+set (OPENCC_VERSION_REVISION 9)
 
 if (CMAKE_BUILD_TYPE MATCHES Debug)
   set (version_suffix .Debug)
@@ -57,7 +57,7 @@
   "${PACKAGE_NAME}-${OPENCC_VERSION_MAJOR}.${OPENCC_VERSION_MINOR}.${OPENCC_VERSION_REVISION}"
 )
 set(CPACK_SOURCE_IGNORE_FILES
-  "/build/;/test/dict.ocd;/test/dict.txt;/test/dict.bin;/other/;/opencc.xcodeproj/;/.git/;.gitignore;~$;.pyc;${CPACK_SOURCE_IGNORE_FILES}"
+  "/build/;/test/dict.ocd;/test/dict.txt;/test/dict.bin;/other/;/opencc.xcodeproj/;/.git/;.gitignore;~$;.pyc;/bazel*;/node_modules;/.github;/.pytest_cache;/.vscode;${CPACK_SOURCE_IGNORE_FILES}"
 )
 include(CPack)
 
@@ -79,10 +79,10 @@
 ######## Directory
 
 set (DIR_PREFIX ${CMAKE_INSTALL_PREFIX})
-set (DIR_INCLUDE ${DIR_PREFIX}/include/)
-set (DIR_SHARE ${DIR_PREFIX}/share/)
-set (DIR_ETC ${DIR_PREFIX}/etc/)
-set (DIR_LIBRARY ${DIR_PREFIX}/lib${LIB_SUFFIX}/)
+set (DIR_INCLUDE ${DIR_PREFIX}/include)
+set (DIR_SHARE ${DIR_PREFIX}/share)
+set (DIR_ETC ${DIR_PREFIX}/etc)
+set (DIR_LIBRARY ${DIR_PREFIX}/lib${LIB_SUFFIX})
 
 if (DEFINED SHARE_INSTALL_PREFIX)
   set (DIR_SHARE ${SHARE_INSTALL_PREFIX})
@@ -100,8 +100,8 @@
   set (DIR_LIBRARY ${LIB_INSTALL_DIR})
 endif (DEFINED LIB_INSTALL_DIR)
 
-set (DIR_SHARE_OPENCC ${DIR_SHARE}/opencc/)
-set (DIR_SHARE_LOCALE ${DIR_SHARE}/locale/)
+set (DIR_SHARE_OPENCC ${DIR_SHARE}/opencc)
+set (DIR_SHARE_LOCALE ${DIR_SHARE}/locale)
 
 ######## Configuration
 
@@ -229,7 +229,7 @@
 
 if (ENABLE_GTEST)
   if(NOT USE_SYSTEM_GTEST)
-    add_subdirectory(deps/gtest-1.12.1)
+    add_subdirectory(deps/googletest-1.15.0)
   endif()
   enable_testing()
 endif()
@@ -248,7 +248,7 @@
   if(USE_SYSTEM_PYBIND11)
     find_package(pybind11 CONFIG)
   else()
-    add_subdirectory(deps/pybind11-2.10.0)
+    add_subdirectory(deps/pybind11-2.13.1)
   endif()
   pybind11_add_module(opencc_clib src/py_opencc.cpp)
   target_link_libraries(opencc_clib PRIVATE libopencc)

=== Makefile ===
--- 
+++ 
@@ -17,13 +17,14 @@
 #
 
 PREFIX = /usr
+REL_BUILD_DOCUMENTATION ?= ON
 
-.PHONY: build clean node test xcode-build
+.PHONY: bazel build clean node test xcode-build
 
 build:
 	mkdir -p build/rel
 	(cd build/rel; cmake \
-	-DBUILD_DOCUMENTATION:BOOL=ON \
+	-DBUILD_DOCUMENTATION:BOOL=${REL_BUILD_DOCUMENTATION} \
 	-DENABLE_GTEST:BOOL=OFF \
 	-DENABLE_BENCHMARK:BOOL=OFF \
 	-DCMAKE_BUILD_TYPE=Release \
@@ -78,13 +79,13 @@
 	xcodebuild build)
 
 python-build:
-	python setup.py build_ext
+	echo "No need to build"
 
 python-install: python-build
-	python setup.py install
+	python -m pip install .
 
 python-dist: python-build
-	python setup.py bdist_wheel
+	python -m build
 
 python-test: python-build
 	cd python; pytest .
@@ -97,7 +98,14 @@
 	| xargs clang-format -i
 
 clean:
-	rm -rf build xcode python/opencc/clib *.egg-info
+	rm -rf build xcode python/opencc/clib *.egg-info bazel-*
 
 install: build
 	make -C build/rel install VERBOSE=${VERBOSE} PREFIX=${PREFIX}
+
+bazel:
+	bazel build //:opencc
+	bazel test --test_output=all //src/... //data/... //test/...
+
+bazel-clean:
+	bazel clean --expunge

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
   include_directories(../deps/rapidjson-1.1.0)
 endif()
 if(NOT USE_SYSTEM_TCLAP)
-  include_directories(../deps/tclap-1.2.2)
+  include_directories(../deps/tclap-1.2.5)
 endif()
 
 # Library
@@ -85,7 +85,7 @@
 if (ENABLE_DARTS)
   set(OPENCC_ENABLE_DARTS 1)
   if(NOT USE_SYSTEM_DARTS)
-    include_directories(../deps/darts-clone)
+    include_directories(../deps/darts-clone-0.32)
   endif()
   set(
     LIBOPENCC_HEADERS

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,4 @@
+include_directories("${PROJECT_SOURCE_DIR}")
 include_directories("${PROJECT_BINARY_DIR}/src")
 include_directories("${PROJECT_SOURCE_DIR}/src")
 
@@ -28,7 +29,7 @@
   endif()
 
   if(NOT USE_SYSTEM_GTEST)
-    include_directories(../deps/gtest-1.7.0/include)
+    include_directories(../deps/googletest-1.15.0/googletest/include)
   endif()
   set(UNITTESTS
     CommandLineConvertTest

=== debian/control ===
Source: opencc
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Debian Chinese Team <chinese-developers@lists.alioth.debian.org>,
 Asias He <asias@debian.org>,
 YunQiang Su <syq@debian.org>,
 Osamu Aoki <osamu@debian.org>,
 Aron Xu <aron@debian.org>,
 xiao sheng wen <atzlinux@sina.com>,
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 chrpath,
 cmake,
 darts,
 debhelper-compat (= 13),
 dh-sequence-python3,
 doxygen <!nodoc>,
 googletest <!nocheck>,
 libmarisa-dev (>> 0.3),
 libtclap-dev,
 opencc <cross>,
 dh-sequence-pkgkde-symbolshelper,
 pybind11-dev,
 python3-dev,
 rapidjson-dev,
 pybuild-plugin-pyproject,
 python3-pytest <!nocheck>,
 python3-setuptools,
 python3-wheel,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Section: libs
Homepage: https://github.com/BYVoid/OpenCC
Vcs-Git: https://salsa.debian.org/debian/opencc.git
Vcs-Browser: https://salsa.debian.org/debian/opencc
Description: simplified-traditional Chinese conversion library
 opencc is a library for converting character between traditional Chinese and
 simplified Chinese.

Package: libopencc-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Breaks:
 libopencc2-data (<< 1.1.1~),
Replaces:
 libopencc2-data (<< 1.1.1~),
Description: ${source:Synopsis} - data files
 ${source:Extended-Description}
 .
 This package includes the data files.

Package: libopencc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libopencc1.1 (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 libopencc-doc,
Description: ${source:Synopsis} - development
 ${source:Extended-Description}
 .
 This package includes the development support files.

Package: libopencc-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends},
Description: ${source:Synopsis} - document
 ${source:Extended-Description}
 .
 This package includes the library document files.

Package: libopencc1.1
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libopencc-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} - runtime
 ${source:Extended-Description}
 .
 This package includes the shared library.

Package: opencc
Section: utils
Architecture: any
Multi-Arch: foreign
Depends:
 libopencc1.1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 libopencc-doc,
Description: simplified-traditional Chinese conversion tool
 ${source:Extended-Description}
 .
 This package includes the conversion tool.

Package: python3-opencc
Section: python
Architecture: any
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} - Python 3.x
 ${source:Extended-Description}
 .
 This package provides the Python 3.x module.

=== debian/rules ===
--- 
+++ 
@@ -11,12 +11,13 @@
 # Disable parallel build to circumvent some random build error
 # (needs further investigation)
 %:
-	dh $@ --buildsystem=cmake --with pkgkde_symbolshelper --no-parallel
+	dh $@ --buildsystem=cmake --no-parallel
 
 BUILD_OPTIONS = \
     -DCMAKE_INSTALL_PREFIX=/usr \
     -DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)/ \
     -DCMAKE_BUILD_TYPE=Release \
+    -DBUILD_PYTHON=ON \
     -DUSE_SYSTEM_DARTS=ON \
     -DUSE_SYSTEM_GTEST=ON \
     -DUSE_SYSTEM_MARISA=ON \
@@ -39,6 +40,22 @@
 override_dh_auto_configure:
 	dh_auto_configure -- $(BUILD_OPTIONS)
 
+execute_after_dh_auto_build:
+	dh_auto_build -O--buildsystem=pybuild -- -s pyproject --after-build \
+		"cp obj-$(DEB_BUILD_GNU_TYPE)/opencc_clib.*.so {build_dir}/opencc/clib/"
+
+execute_after_dh_auto_test:
+	# TODO: Correctly test Python build for opencc 1.1.9+
+	-dh_auto_test -O--buildsystem=pybuild -- -s pyproject
+
+execute_after_dh_auto_install:
+	dh_auto_install -O--buildsystem=pybuild -- -s pyproject
+	chrpath --delete debian/tmp/usr/lib/*/dist-packages/opencc/clib/*.so
+	for i in debian/tmp/usr/lib/*/dist-packages/opencc/clib/; do \
+		mkdir -p $$i/share/; \
+		ln -sf ../../../../../../share/opencc $$i/share/; \
+	done
+
 execute_after_dh_auto_clean:
 	find . -name *.pyc -delete

=== debian/tests/control ===
Tests: integration
Depends:
 build-essential,
 cmake,
 googletest,
 pkgconf,
 @,
Restrictions: allow-stderr,

=== debian/watch ===
version=4
opts="dversionmangle=s/\+ds\d?$//,repack,repacksuffix=+ds1,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
 https://github.com/byvoid/@PACKAGE@/tags \
 (?:.*?/)?(?:ver\.)?@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate
